﻿// gdplayer 0.9.3 Vista/7
// 10.12.2010
// Copyright 2009 - 2010 Zdenek Canik
// All Rights Reserved.
// http://gdplayer.blogspot.com

var opt_stream = new Array();
var opt_group = new Array();
var opt_id = 0;
var opt_bgrd_id;
var focus_id = 0;
var server_groups = new Array();
var move_group = "";

function onOpen() {
	fnGetDefaultPlaylist();
	form.lst_groups.selectedIndex = 0;
	form.lst_stations.selectedIndex = 0;
	opt_bgrd_id = System.Gadget.document.parentWindow.bgrd_id;
	
	document.getElementById("preview").src = "../images/bgrd_" + opt_bgrd_id + "_docked.png";
	//document.getElementById("chk_onlineplaylist").checked = System.Gadget.document.parentWindow.online_playlist;
	document.getElementById("chk_autoplay").checked = System.Gadget.document.parentWindow.auto_play;
	document.getElementById("chk_updates").checked = System.Gadget.document.parentWindow.updates;
	document.getElementById("chk_datetime").checked = System.Gadget.document.parentWindow.date_time;
	document.getElementById("chk_ampm0").checked = System.Gadget.document.parentWindow.am_pm;
	document.getElementById("chk_ampm1").checked = !System.Gadget.document.parentWindow.am_pm;
	document.getElementById("btn_1").title = NEW;
	document.getElementById("btn_2").title = EDIT;
	document.getElementById("btn_3").title = DELETE;
	document.getElementById("btn_4").title = MARK;
	document.getElementById("btn_5").title = NEW;
	document.getElementById("btn_6").title = EDIT;
	document.getElementById("btn_7").title = DELETE;
	document.getElementById("btn_8").title = MOVE;
	document.getElementById("btn_9").title = OPT_ONLINEDBASE;
	document.getElementById("btn_10").title = OPT_DOWNLOAD;
	document.getElementById("btn_11").title = OPT_CLOSE;
	document.getElementById("btn_12").title = OPT_BGRD;
	document.getElementById("btn_13").title = OPT_BGRD;
	
	opt_info.innerHTML = OPT_INFO;
}

// ------------------------------------------------------------------- ON OK
System.Gadget.onSettingsClosing = settingsClosing;
function settingsClosing(event) {
	if (event.closeAction == event.Action.commit) {
		// OK
		System.Gadget.Settings.write("bgrd", opt_bgrd_id);
		//System.Gadget.Settings.write("online_playlist", form.chk_onlineplaylist.checked);
		System.Gadget.Settings.write("auto_play", form.chk_autoplay.checked);
		System.Gadget.Settings.write("updates", form.chk_updates.checked);
		System.Gadget.Settings.write("date_time", form.chk_datetime.checked);
		System.Gadget.Settings.write("am_pm", form.chk_ampm0.checked);
		fnSaveGDPXML();
	}
	event.cancel = false;
}

function fnGetDefaultPlaylist() {
	//alert("options : loading local playlist...");
	var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
	try {
		xmlDoc.async = false;
		var result = xmlDoc.load("gdplayer_playlist.xml");
		if (!result) {
			//alert("local gdplayer_playlist.xml : not found");
			return;
		}
		//alert("gdplayer_playlist.xml is loaded & ready for use...");
		fnGetData(xmlDoc);
		fnUpdateLstGroups();
	} catch(e) {
		//alert(e.message)
	}
}
function fnGetData(data) {
	opt_group = [];
	opt_stream = [];

	var parseError = data.parseError;
	if (parseError.errorCode != 0) { 
		//alert(parseError.reason); 
	}
	var objGroupList = data.getElementsByTagName("group");
	//alert("found : " + objGroupList.length + " group(s)");

	var id=-1;
	for (var i = 0; i < objGroupList.length; ++i) {
		var xmlItem = objGroupList.item(i);
		opt_group[i] = xmlItem.getAttribute("name");
		
		for (var j = 0; j < xmlItem.childNodes.length; ++j) {
			var child = xmlItem.childNodes.item(j);
			if (child.childNodes.length > 0) {
				++id;
				try {
					var http = child.childNodes[2].childNodes[0].nodeValue;
				} catch (e) {
					var http = "none";
				}
				opt_stream[id] = {
					name:child.childNodes[0].childNodes[0].nodeValue,
					url:child.childNodes[1].childNodes[0].nodeValue,
					homepage:http,
					group:opt_group[i]
				};
			}
		}
	}
}

// ------------------------------------------------------------------- GROUP TOOLS
function fnUpdateLstGroups(data) {
	form.lst_groups.options.length = opt_group.length;
	for (var i = 0; i < opt_group.length; ++i) {
		form.lst_groups.options[i].text = opt_group[i];	
		if (opt_group[i] == move_group) { 
			form.lst_groups.options[i].style.color = "#FF0000";
		} else { 
			form.lst_groups.options[i].style.color = "#000000";
		}
	}
	form.lst_groups.selectedIndex = 0;
	fnUpdateLstStreams();
}
function fnNewGroup() {
	var name = prompt(OPT_NEWGROUP + ":","");

	if(name) { 
		opt_group.push(name);
		fnUpdateLstGroups();
		form.lst_groups.selectedIndex = opt_group.length - 1;
	}
}
function fnDelGroup() {
	var temp_array = [];
	var str = "";

	for (var i=0; i<form.lst_groups.options.length; ++i) {
		if(form.lst_groups.children(i).selected) { 
			temp_array.push(opt_group[i]);
			str += "     " + opt_group[i] +"\n";
		}
	}

	if (confirm(OPT_DEL + " ? (" + temp_array.length + " " + OPT_GROUPS + ")\n\n" + str)) {
		for (var i=0; i<temp_array.length; ++i) {
			for (var j=0; j<opt_group.length; j++) {
				if (opt_group[j] == temp_array[i]) { 
					if (move_group == temp_array[i]) { move_group = ""; }
					opt_group.splice(j,1); 
				}
			}
		}
		fnUpdateLstGroups();
		fnUpdateLstStreams();
	} else {         
		//good choise ;)
	}
}
function fnEditGroup() {
	if (!opt_group[form.lst_groups.selectedIndex]) { return; }
	var old_name = opt_group[form.lst_groups.selectedIndex];
	var new_name = prompt(OPT_ENTERNAME + ": ", old_name);
	
	if(new_name) { 
		opt_group[form.lst_groups.selectedIndex] = new_name; 
		for (var i = 0; i < opt_stream.length; ++i) {	
			if (opt_stream[i].group == old_name) { opt_stream[i].group = new_name; }
		}
		fnUpdateLstGroups();
	}
}
function fnGroupMoveUp() {
	var strTemp = new Array();
	var idTemp;

	var x = form.lst_groups.selectedIndex;
	
	var id = x;
	if ((id == null) || (id == 0)) { return; }

	idTemp = (id > 0) ? id-- : "";
	strTemp = opt_group[idTemp];

	opt_group[idTemp] = opt_group[id];
	opt_group[id] = strTemp;
	
	fnReloadArrays();
	fnUpdateLstGroups();
	
	x != 0 ? --x : "";
	form.lst_groups.selectedIndex = x;
}
function fnGroupMoveDown() {
	var strTemp = new Array();
	var idTemp;

	var x = form.lst_groups.selectedIndex;
	
	var id = x;
		if ((id == null) || (id == (opt_group.length) - 1)) { return; }

	idTemp = (id <= opt_group.length) ? id++ : "";
	strTemp = opt_group[idTemp];

	opt_group[idTemp] = opt_group[id];
	opt_group[id] = strTemp;
	
	fnReloadArrays();
	fnUpdateLstGroups();
	
	x != (form.lst_groups.options.length) - 1 ? ++x : "";
	form.lst_groups.selectedIndex = x;
}

// ------------------------------------------------------------------- STREAMS TOOLS
function fnUpdateLstStreams() {
	if (opt_stream.length == 0) { return; }
	var id = form.lst_groups.selectedIndex;
	form.lst_stations.options.length = 0;
	var x = -1;
	for (var i = 0; i < opt_stream.length; ++i) {	
		if (opt_stream[i].group == form.lst_groups.options[id].text) {
			form.lst_stations.options.length++;
			x++;
			form.lst_stations.options[x].text = opt_stream[i].name;
		}
	}
	//btn_move.caption = MOVE + " : " +  opt_stream[opt_id].name + " > " + opt_group[lst_groups.selectedIndex];
}
function fnNewStream() {
	if (!opt_group[form.lst_groups.selectedIndex]) { return; }
	var name = prompt(OPT_NEWSTREAM + ":","");
	if (name) {
		var url = prompt(OPT_NEWURL + ":","http://");
		var homepage = prompt(OPT_HOMEPAGE + ":","http://");
		var group = opt_group[form.lst_groups.selectedIndex];
	}
	if (name && url) {
		opt_stream[opt_stream.length] = { name:name, url:url, homepage:homepage, group:group };
		fnUpdateLstStreams();
	}
}
function fnDelStream() {
	var temp_array = [];
	var str = "";
	var group = opt_group[form.lst_groups.selectedIndex];

	for (var i=0; i<form.lst_stations.options.length; ++i) {
		if(form.lst_stations.children(i).selected) { 
			temp_array.push(form.lst_stations.children(i).text);
			str += "     " + form.lst_stations.children(i).text +"\n";
		}
	}
	if (temp_array.length == 0) { return; }
	if (confirm(OPT_DEL + " ? (" + temp_array.length + " " + OPT_STATIONS + ")\n\n" + str + "\n " + OPT_GROUP + ": " + group)) {
		for (var i=0; i<temp_array.length; ++i) {
			for (var j = 0; j < opt_stream.length; j++) {
				if (opt_stream[j].name == temp_array[i] && opt_stream[j].group == group) { 
					opt_stream.splice(j,1);
					//alert("del: " + temp_array[i]);
				}
			}
		}
		fnUpdateLstStreams();
	} else {         
		//good choise ;)
	}
}
function fnEditStream() {
	var id = fnGetId();
	if (id == null) { return; }
	var old_name = opt_stream[id].name;
	var new_name = prompt(OPT_ENTERNAME + ": ", old_name);
	if (new_name) { 
		opt_stream[id].name = new_name; 
		fnUpdateLstStreams();
	
		var old_url = opt_stream[id].url;
		var new_url = prompt(OPT_NEWURL + ": ", old_url);
		if (new_url) { 
			opt_stream[id].url = new_url; 
			fnUpdateLstStreams();
		
			var old_homepage = opt_stream[id].homepage;
			var new_homepage = prompt(OPT_HOMEPAGE + ": ", old_homepage);
			if (new_homepage) { 
				opt_stream[id].homepage = new_homepage; 
				fnUpdateLstStreams();
			}
		}
	}
}
function fnStreamMoveUp() {
	var strTemp = new Array();
	var idTemp;

	var x = form.lst_stations.selectedIndex;
	
	var id = fnGetId();
	if ((id == null) || (id == 0)) { return; }

	idTemp = (id > 0) ? id-- : "";
	strTemp = opt_stream[idTemp];

	opt_stream[idTemp] = opt_stream[id];
	opt_stream[id] = strTemp;
	
	fnReloadArrays();
	fnUpdateLstStreams();
	
	x != 0 ? --x : "";
	form.lst_stations.selectedIndex = x;
}
function fnStreamMoveDown() {
	var strTemp = new Array();
	var idTemp;

	var x = form.lst_stations.selectedIndex;
	
	var id = fnGetId();
	if ((id == null) || (id == (opt_stream.length) - 1)) { return; }

	idTemp = (id <= opt_stream.length) ? id++ : "";
	strTemp = opt_stream[idTemp];

	opt_stream[idTemp] = opt_stream[id];
	opt_stream[id] = strTemp;
	
	fnReloadArrays();
	fnUpdateLstStreams();

	x != (form.lst_stations.options.length) - 1 ? ++x : "";
	form.lst_stations.selectedIndex = x;
}
//----------------------------------------------------------------------------------- MOVE STREAM
function fnMarkGroup() {
	move_group = opt_group[form.lst_groups.selectedIndex];
	if (!move_group) { return; }
	var str = "";
	var selected = form.lst_groups.selectedIndex;

	str += "Target group: <b>" + move_group + "</b>";
	
	opt_info.innerHTML = str;
	fnUpdateLstGroups();
	form.lst_groups.selectedIndex = selected;
}
function fnMoveStream() {
	var temp_array = [];
	var str = "";
	var group = opt_group[form.lst_groups.selectedIndex];
	
	if (move_group == "") { 
		alert ("Select target group.");
		return;
	}

	for (var i=0; i<form.lst_stations.options.length; ++i) {
		if(form.lst_stations.children(i).selected) { 
			temp_array.push(form.lst_stations.children(i).text);
			str += "     " + form.lst_stations.children(i).text +"\n";
		}
	}
	
	if ( temp_array.length == 0) { return; }
	
	if (confirm("Wish to move " + temp_array.length + " station(s) into [ " + move_group + " ] group?\n\n" + str + "\n Group: " + group)) {
		for (var i=0; i<temp_array.length; ++i) {
			for (var j = 0; j < opt_stream.length; j++) {
				if (opt_stream[j].name == temp_array[i] && opt_stream[j].group == group) {
					opt_stream[j].group = move_group;
				}
			}
		}
		fnUpdateLstStreams();
	} else {         
		//good choise ;)
	}
}

//----------------------------------------------------------------------------------- GET ID!
function fnGetId() {
	try {
		var name = form.lst_stations.options[form.lst_stations.selectedIndex].text;	
		var group = opt_group[form.lst_groups.selectedIndex];
	} catch(e) { 
		return; 
	}
	var id = null;
	
	for (var i = 0; i < opt_stream.length; i++) {
		if (group == opt_stream[i].group && name == opt_stream[i].name) { id = i; }
	}	
	//alert("fnGetId : [" + id + "] " + name + " - " + group);
	opt_id = id;
	return id;
}

//----------------------------------------------------------------------------------- CLICK
function fnGetURL() {
	var id = fnGetId();
	if (id == null) { return; }
	
	var str = "<b>" + opt_stream[id].name + "</b>    (" + opt_stream[id].group + ")<br>";
	str +=  "<a href='" + opt_stream[id].homepage + "'>"+ opt_stream[id].homepage + "</a><br>";
	str +=  opt_stream[id].url;
	document.getElementById("opt_info").innerHTML = str;
}

function fnFocusOFF() {
	focus_id = 0;
}
function fnFocusON() {
	focus_id = 1;
}

//----------------------------------------------------------------------------------- KEY DOWN
function fnOptKeyDown() {
  var KeyID = event.keyCode;
	switch (KeyID) {
		case 46: // delete
			focus_id == 0 ? fnDelGroup() : fnDelStream();
		break;
		case 107: // num +
			focus_id == 0 ? fnGroupMoveDown() : fnStreamMoveDown();
		break;
		case 109: // num -
			focus_id == 0 ? fnGroupMoveUp() : fnStreamMoveUp();
		break;

	}
}

// ------------------------------------------------------------------- SAVE MODIFIED gdplayer_playlist.xml
function fnSaveGDPXML() {

	var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
	xmlDoc.async = false;

	var xml_string = "<?xml version=\"1.0\" encoding=\"windows-1250\"?>\n";
	xml_string += "<general>\n";

	for (var i=0; i<opt_group.length; ++i) {
		xml_string += "<group name='" + opt_group[i] + "'>\n";
		for (var j=0; j<opt_stream.length; ++j) {
			if (opt_stream[j].group == opt_group[i]) {
				xml_string += "<stream>\n";
				xml_string += "<name>" + opt_stream[j].name + "</name>\n";
				xml_string += "<url>" + opt_stream[j].url +"</url>\n";
				xml_string += "<homepage>" + opt_stream[j].homepage +"</homepage>\n";
				xml_string += "</stream>\n";
			}
		}
		xml_string += "</group>\n";
	}
	xml_string += "</general>";
	
	xmlDoc.loadXML(xml_string);

	try {
		var parseError = xmlDoc.parseError;
		if (parseError.errorCode == 0) {
			xmlDoc.save(System.Gadget.path + "\\gdplayer_playlist.xml");
			xmlDoc.close;
			//alert("gdplayer_playlist.xml saved...");
		}
	} catch(e) {
		//alert(e.message);
		lbl_title.innerText = "failed to save playlist";
		//debug.error("failed to save playlist");
		return;
	}
}

// ------------------------------------------------------------------- REINDEX ARRAYS
function fnReloadArrays() {
	var tempArray_1 = new Array();
	var tempArray_2 = new Array();
	var id;

	tempArray_2[0] = { name:"",url:"",homepage:"",group:"" };

	id = 0;
	for (var i=0; i<opt_group.length; ++i) {
		tempArray_1.push(opt_group[i]);
		for (var j=0; j<opt_stream.length; ++j) {
			if (opt_stream[j].group == opt_group[i]) {
				id = ++id;
				tempArray_2[id] = opt_stream[j];
			}
		}
	}
	opt_group = tempArray_1;
	opt_stream = tempArray_2;
}

// ------------------------------------------------------------------- CHANGE BACKGROUND
function fnChangeBgrd() {	
	++opt_bgrd_id;
	if (opt_bgrd_id > 11) { opt_bgrd_id = 1; }
	document.getElementById("preview").src = "images/bgrd_" + opt_bgrd_id + "_docked.png";
}

// ------------------------------------------------------------------- CHANGE BACKGROUND
function fnBgrdLeft() {
	--opt_bgrd_id;
	if (opt_bgrd_id < 1) { opt_bgrd_id = 11; }
	document.getElementById("preview").src = "images/bgrd_" + opt_bgrd_id + "_docked.png";
}

function fnBgrdRight() {
	++opt_bgrd_id;
	if (opt_bgrd_id > 11) { opt_bgrd_id = 1; }
	document.getElementById("preview").src = "images/bgrd_" + opt_bgrd_id + "_docked.png";
}
// ------------------------------------------------------------------- ONLINE UPDATE
function fnOnline() {	
	div_stations.style.visibility = "hidden";
	div_server.style.visibility = "visible";
	fnGetGroupsXML();
}
// ------------------------------------------------------------------- DOWNLOAD GROUPS LIST FROM SERVER
function fnGetGroupsXML() {
	//alert("downloading groups list from server...");
	try {
		var req = new ActiveXObject("MSXML2.XMLHTTP.3.0");
		//var url = "http://127.0.0.1/groups/groups.xml" + "?r=" + Math.random();
		//var url = "http://www.xata.ic.cz/groups/groups.xml" + "?r=" + Math.random();
		var url = "http://gdplayer.4fan.cz/groups/groups.xml?r=" + Math.random();
		req.open("GET", url, false);
		req.onreadystatechange = function() {
			if (req.readyState == 4) {
				if (req.status == 200) {
					var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
					xmlDoc.async = false;
					xmlDoc = req.responseXml;
					//alert("groups.xml is downloaded & ready for use...\n" + url + " - " + req.statusText);
					fnMakeGroupList(xmlDoc);
				}
			}
		};
		req.send();
	} catch(e) {
		//alert(e.message);
	}
}
function fnMakeGroupList(data) {
	var parseError = data.parseError;

	if (parseError.errorCode != 0) {
		//alert(parseError.errorCode);
	}
	//alert("2...");
	var objGroupList = data.getElementsByTagName("group");
	//alert("found : " + objGroupList.length + " group(s)");
	
	for (var i = 0; i < objGroupList.length; ++i) {5
		var xmlItem = objGroupList.item(i);
		var child = xmlItem.childNodes.item(0);
		server_groups[i] = { 
			name:xmlItem.getAttribute("name"),
			//filename:child.childNodes[0].nodeValue
			filename:xmlItem.childNodes[0].childNodes[0].nodeValue,
			stations:xmlItem.childNodes[1].childNodes[0].nodeValue
		};
	}
	//lbl_title.innerText = server_groups.length + " groups added";
	form.lst_server.options.length = server_groups.length;
	for (var i = 0; i < server_groups.length; ++i) {
		form.lst_server.options[i].text = server_groups[i].name + "  (" + server_groups[i].stations + ")";
	}
}

function fnGetGroup() {
	var filename;
	filename = server_groups[form.lst_server.selectedIndex].filename;

	var req = new ActiveXObject("MSXML2.XMLHTTP.3.0");
	//var url = "http://127.0.0.1/groups/" + filename + ".xml?r=" + Math.random();
	var url = "http://gdplayer.4fan.cz/groups/" + filename + ".xml?r=" + Math.random();
	
	//alert("downloading group : " + url);
	req.open("GET", url, true);
	req.onreadystatechange = function() {
		if (req.readyState == 4) {
			if (req.status == 200) {
				var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
				xmlDoc.async = false;
				xmlDoc = req.responseXml;
				//alert("group [ " + filename + ".xml ] is loaded & ready for use...");
				fnAddGroup(xmlDoc);
			}
		}
    };
	req.send();
}

function fnAddGroup(data) {
	//alert("adding group to menu...");
	var parseError = data.parseError;
	if (parseError.errorCode != 0) {  
		//alert(parseError.reason); 
	}

	var objGroupList = data.getElementsByTagName("group");
	for (var i = 0; i < objGroupList.length; ++i) {
		var xmlItem = objGroupList.item(i);
		var group_name = xmlItem.getAttribute("name");
		var a = false;
		for (var j = 0; j < opt_group.length; ++j) {
				if (opt_group[j] == group_name) { a = true; }
		}
		if (!a) { 
			opt_group.push(group_name);
			//lbl_title.innerText = GROUP_ADDED;
		}

		var x = opt_stream.length - 1;
		for (var j = 0; j < xmlItem.childNodes.length; ++j) {
			var child = xmlItem.childNodes.item(j);
			if (child.childNodes.length > 0) {
				var name = child.childNodes[0].childNodes[0].nodeValue;
				a = false;
				for (var k = 0; k < opt_stream.length; ++k) {
					if ((opt_stream[k].name == name) && (opt_stream[k].group == group_name )) { 
						var a = true;
						opt_stream[k].url = child.childNodes[1].childNodes[0].nodeValue;
						
					}	
				}
				if (!a) {
					try {
						var http = child.childNodes[2].childNodes[0].nodeValue;
					} catch(e) {
						var http = "none";
					}
					//alert("new stream : " + name + " @ " + child.childNodes[1].childNodes[0].nodeValue + " *** " + http);
					++x;
					opt_stream[x] = {
						name:name,
						url:child.childNodes[1].childNodes[0].nodeValue,
						homepage:http,
						group:group_name
					};
				}
			}
		}
			
	}
	
	var str = OPT_GROUP_ADDED + ": <b>" + group_name + "</b>    (" +  xmlItem.childNodes.length + " " + OPT_STATIONS+ ")";
	document.getElementById("opt_info").innerHTML = str;
	
	fnSaveGDPXML();
	fnGetDefaultPlaylist();
}

function fnOK() {
	fnUpdateLstStreams();
	div_stations.style.visibility = "visible";
	div_server.style.visibility = "hidden";
}

function updateImage(objImage, action, state) {
        objImage.src = "images/" + action + "_" + state + ".png";
}