﻿// gdplayer 0.9.3 Vista/7
// 10.12.2010
// Copyright 2009 - 2010 Zdenek Canik
// All Rights Reserved.
// http://gdplayer.blogspot.com

var files = [];
var pls_id;
var intval;
// ------------------------------------------------------------------- LOAD LOCAL gdplayer_playlist.xml
function fnLoadMyList() {
	//alert("loading local playlist...");
	var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
	try {
		xmlDoc.async = false;
		var result = xmlDoc.load("gdplayer_playlist.xml");
		if (!result) {
			//alert("local gdplayer_playlist.xml : not found");
			status_bank = 0;
			fnRefreshStatus();
			return;
		}
		//alert("gdplayer_playlist.xml is loaded & ready for use...");
		fnGetArrays(xmlDoc);
	} catch(e) {
		//alert(e.message)
	}
}

function fnGetArrays(data) {
	//alert("parsing...");
	group = [];
	stream = [];

	var parseError = data.parseError;
	if (parseError.errorCode != 0) { 
		//alert(parseError.reason); 
	}

	var objGroupList = data.getElementsByTagName("group");
	//alert("found : " + objGroupList.length + " group(s)");
	
	var id=-1;
	for (var i = 0; i < objGroupList.length; ++i) {
		var xmlItem = objGroupList.item(i);
		group[i] = xmlItem.getAttribute("name");
		
		for (var j = 0; j < xmlItem.childNodes.length; ++j) {
			var child = xmlItem.childNodes.item(j);
			if (child.childNodes.length > 0) {
				++id;
				try {
					var http = child.childNodes[2].childNodes[0].nodeValue;
				} catch (e) {
					var http = "none";
				}
				stream[id] = {
					name:child.childNodes[0].childNodes[0].nodeValue,
					url:child.childNodes[1].childNodes[0].nodeValue,
					homepage:http,
					group:group[i]
				};
			}
		}
	}
	//alert("found : " + stream.length + " stream(s)");
	//id = options.getValue("last_stream");
	
	if (stream.length > 0) {
		lbl_title.innerText = gdp_version;
	} else {
		lbl_station.innerText = "";
		lbl_title.innerText = gdp_version + "\n" + EMPTY_PLAYLIST;
		lbl_status.innerText = "";
	}
}

// ------------------------------------------------------------------- DOWNLOAD & ADD GROUP
function fnGetAllGroup() {
	for (var i = 0; i < server_groups.length; ++i) {
		fnGetGroup(server_groups[i].name);
	}
}

function fnAddGroup(data) {
//	debug.info("adding group to menu...");

	var parseError = data.parseError;
	if (parseError.errorCode != 0) {
		//debug.error(parseError.reason);
	}

	var objGroupList = data.getElementsByTagName("group");
	
	for (var i = 0; i < objGroupList.length; ++i) {
		var xmlItem = objGroupList.item(i);
		var group_name = xmlItem.getAttribute("name");
		var a = false;
		for (var j = 0; j < group.length; ++j) {
				if (group[j] == group_name) { a = true; }
		}
		if (!a) { 
			group.push(group_name);
			lbl_title.innerText = GROUP_ADDED;
		}

		var x = stream.length - 1;
		for (var j = 0; j < xmlItem.childNodes.length; ++j) {
			var child = xmlItem.childNodes.item(j);
			if (child.childNodes.length > 0) {
				var name = child.childNodes[0].childNodes[0].nodeValue;
				a = false;
				for (var k = 0; k < stream.length; ++k) {
					if ((stream[k].name == name) && (stream[k].group == group_name )) { 
						var a = true;
						stream[k].url = child.childNodes[1].childNodes[0].nodeValue;
						
					}	
				}
				if (!a) {
					try {
						var http = child.childNodes[2].childNodes[0].nodeValue;
					} catch(e) {
						var http = "none";
					}
					//alert("new stream : " + name + " @ " + child.childNodes[1].childNodes[0].nodeValue + " *** " + http);
					++x;
					stream[x] = {
						name:name,
						url:child.childNodes[1].childNodes[0].nodeValue,
						homepage:http,
						group:group_name
					};
				}
			}
		}
			
	}

	fnSaveMylistXML();

	lbl_station.innerText = stream[id].name;
}

// ------------------------------------------------------------------- PARSE AND PLAY .PLS
function fnPlayPLS() {
	pls_id = 0;

	try {	
		//alert("downloading .pls playlist...");
		var allText;
		var lines = [];
		files = [];
		var req = new XMLHttpRequest();

		player.controls.stop();
		player.url  = "";
		btn_playstop.src = "images/btn_play.png";
		btn_playstop.alt = "Play";
		document.getElementById("btn_playstop").onclick= function() { fnPlay(); }
		
		//alert("player : " + player.playState);
		req.open("GET", stream[id].url, false);
		req.onreadystatechange = function() {
			if (req.readyState == 4) {
				lines = req.responseText.split("\n");
				for (var i = 0; i < lines.length; ++i) {
					if (lines[i].slice(0,4) == "File") {
						var a = lines[i].indexOf("=") + 1;
						files.push(lines[i].substr(a));
					}
				}
			}
		};
		req.send();
		//alert("entries : " + files.length);
		setTimeout('fnCheckPlayer()',0);
	} catch(e) {
		//alert(e.message);
	}
}

function fnCheckPlayer() {
	if (player.playState == 3 || pls_id >= files.length) { return; }
	if ((player.playState != 10) && (player.playState != 0)) { 
		setTimeout('fnCheckPlayer()',2000);
		return; 
	}
	
	player.url = files[pls_id];
	//debug.trace("play : " + player.url);
	player.controls.play();
	btn_playstop.src = "images/btn_stop.png";
	btn_playstop.alt = "Stop";
	document.getElementById("btn_playstop").onclick= function() { fnStop(); }
	pls_id++;
}

