﻿// gdplayer 0.9.3 Vista/7
// 10.12.2010
// Copyright 2009 - 2010 Zdenek Canik
// All Rights Reserved.
// http://gdplayer.blogspot.com

var version = 093;
var gdp_version = "gdplayer " + System.Gadget.version;
var bgrd = 1;
var id = 0;
var temp_id = 0;

var stream = new Array();
var group = new Array();

var online_playlist = false;
var date_time = false;
var am_pm = true;
var last_date = null;
var anim = null;

var auto_play = true;
var updates = true;

var status_timeout = 9;
var status_enabled = true;
var status_data = "";
var status_bank = 1;
var opacity = 10;
var buttons_visible = false;
var ctrl_state = false;

System.Gadget.settingsUI = "options.html";
System.Gadget.onSettingsClosed = settingsClosed; 

System.Gadget.onDock = fnChkState;
System.Gadget.onUndock = fnChkState;

function settingsClosed(p_event) {
    //OK clicked?
    if (p_event.closeAction == p_event.Action.commit) {
		getSettings();
		document.getElementById("bgrd").src = "images/bgrd_" + bgrd_id + ".png";
		date_time == true ? time.style.visibility = "visible" : time.style.visibility = "hidden";
		fnChkState();
		fnLoadMyList();
    }
}
//-------------------------------------- GET SETTINGS
function getSettings() {
	try {
		if (getValue("last_stream") == "") { id = 0; } else { id = getValue("last_stream"); }
		if (!getValue("bgrd")) { bgrd_id =  1; } else { bgrd_id = getValue("bgrd"); }
		if (getValue("auto_play" == "")) { auto_play = true; } else { auto_play = getValue("auto_play"); }
		if (getValue("updates" == "")) { updates = true; } else { updates = getValue("updates"); }
		if (getValue("date_time" == "")) { date_time = false; } else { date_time = getValue("date_time"); }
		if (getValue("am_pm" == "")) { am_pm =  true; } else { am_pm = getValue("am_pm"); }
		volume = getValue("volume") ? getValue("volume") : 50;
		//alert("id:"+id+"\nbgrd_id:"+bgrd_id+"\nauto_play:"+auto_play+"\ndate_time:"+date_time+"\nam_pm:"+am_pm+"\nvolume:"+volume+"\nupdates: "+updates);
		} catch(err) {
		//alert("id:"+id+"\nbgrd_id:"+bgrd_id+"\nauto_play:"+auto_play+"\ndate_time:"+date_time+"\nam_pm:"+am_pm);
		alert("Error: ",err.description);
		}
}

function getValue(variable) {
	return System.Gadget.Settings.read(variable);
}
function putValue(variable,value) {
	System.Gadget.Settings.write(variable, value);
}

//-------------------------------------- ON OPEN
function view_onOpen() {
	getSettings();
	fnLoadMyList();
	temp_id = id;
	
	bgrd.src = "images/bgrd_" + bgrd_id + ".png";
	document.getElementById("lbl_station").style.filter = 'alpha(opacity=80)';
	document.getElementById("lbl_title").style.filter = 'alpha(opacity=80)';
	document.getElementById("lbl_date").style.filter = 'alpha(opacity=80)';
	document.getElementById("volume_handle").style.left = volume;
	
	fnFadeOut();
	fnTimeUpdate();

	fnChangeTooltips(id);
	btn_mute.alt = MUTE;
	document.getElementById("volume_root").title = VOLUME;
	document.getElementById("volume_handle").title = VOLUME;

	fnRefreshStatus();
	setInterval('fnTimeUpdate()', 1000);

	var data = "<a href='http://www.google.com/'><img src='images/btn_search.png' alt='Google'></a>";		
	lbl_search.innerHTML = data;
	
	if (updates) { fnChkUpdates(); }
}
//-------------------------------------- NEXT / PREV
function fnNextStation() {
	if (!stream.length > 0) { return; }
	temp_id == stream.length - 1 ? temp_id = 0 : temp_id++;
	fnUpdateInfo();
}

function fnPrevStation() {
	if (!stream.length > 0) { return; }
	temp_id == 0 ? temp_id = stream.length - 1 : temp_id--;
	fnUpdateInfo();
}

function fnUpdateInfo() {
	status_bank = 97;
	fnRefreshStatus();

	btn_playstop.src = "images/btn_play.png";
	document.getElementById("btn_playstop").onclick = function() { fnPlay(); }

	if (auto_play) {
		id = temp_id;
		fnPlay(); 
	}
}

//-------------------------------------- PLAY / STOP
function fnPlay() {
	if (!stream.length > 0) { return; }
	try {
		if (id != temp_id) { id = temp_id; }
		System.Gadget.Settings.write("last_stream", id);
		document.getElementById("lbl_station").innerHTML = "<a href='javascript:fnGetMediaInfo();'>" + stream[id].name + "</a>";
		
		lbl_title.innerText = "";
		
		btn_playstop.src = "images/btn_stop.png";
		fnChangeTooltips(id);
		btn_playstop.alt = STOP;
		
		document.getElementById("btn_playstop").onclick= function() { fnStop(); }

		var url = stream[id].url;
		var a = url.length - 4;
		if (url.substring(a) == ".pls") {
			fnPlayPLS();
		} else {
			player.url =  stream[id].url;
			//alert("play : [ " + id + " ] " + stream[id].name + " @ " + player.url);
			player.controls.play();
		}
	} catch(e) {
		//alert("play: " + e.message);
		status_bank = 96;
	}
}
function fnStop() {
	player.controls.stop();
	btn_playstop.src = "images/btn_play.png";
	btn_playstop.alt = PLAY + " (" + stream[id].name + ")";
	status_bank = 1;
	fnRefreshStatus();
	document.getElementById("btn_playstop").onclick= function() { fnPlay(); }
	
	var data = "<a href='http://www.google.com/'><img src='images/btn_search.png' alt='Google'></a>";		
	lbl_search.innerHTML = data;
	return;
}
//-------------------------------------- VOLUME
function fnSetVolume(pixelVolume){
	var volume=Math.round(pixelVolume);
	 fnVolumeChange(volume);
}
function fnVolumeChange(x) {
	var volume = player.settings.volume + x;
	player.settings.volume = x;
	status_bank = 98;
	fnRefreshStatus();
	putValue("volume",x);
}
function fnMute() {
	var mute = player.settings.mute;
	mute = !mute;
	player.settings.mute = mute;

	if(mute) {
		btn_mute.src = "images/btn_mute_on.png";
	} else {
		btn_mute.src = "images/btn_mute_off.png";
	}
}

//-------------------------------------- MOUSE WHEEL
function fnMouseWheel() {
  if (event.wheelDelta > 0) {
		switch (ctrl_state) {
			case 16:	// shift + wheel
				fnVolumeChange(player.settings.volume + 5);
				document.getElementById("volume_handle").style.left = player.settings.volume;
			break;
			default:
				fnPrevStation(); // wheel only
		}
  } else {
		switch (ctrl_state) {
			case 16:	
				fnVolumeChange(player.settings.volume - 5);
				document.getElementById("volume_handle").style.left = player.settings.volume;
			break;
			default:
				fnNextStation();
		}
	}
}

//-------------------------------------- KEY DOWN / UP
function fnKeyDown() {
  var KeyID = event.keyCode;
	//alert(KeyID);
	switch (KeyID) {
		case 16: // shift
			ctrl_state = KeyID;
		break;
		case 17: // ctrl
			ctrl_state = KeyID;
		break;
		case 32: // space
			if (player.playstate == 3) { 
				fnStop(); 
			} else {
				fnPlay();
			}
		break;
		case 37: // <-
			fnPrevStation();
		break;
		case 38: // arrow up
			if (volume_bar.value > 99) { volume_bar.value = 100; return; }
			fnVolumeChange(player.settings.volume + 5);
			document.getElementById("volume_handle").style.left = player.settings.volume;
		break;
		case 39: // ->
			fnNextStation();
		break;
		case 40: // arrow down
			if (volume_bar.value < 1) { volume_bar.value = 0; return; }	
			fnVolumeChange(player.settings.volume - 5);
			document.getElementById("volume_handle").style.left = player.settings.volume;
		break;
		case 77: // M
			fnMute();
		break;
	}
}
function fnKeyUp() {
	ctrl_state = 0;
}

//-------------------------------------- REFRESH STATUS
function fnRefreshStatus() {
	if (status_bank > 10) {
		fnIsAnimating();
		document.getElementById("lbl_status").style.filter = 'alpha(opacity=100)';
	}
//alert("status:" + status_bank);
	switch (status_bank) {
		case 0: //default
			//lbl_station.innerText  = "";
			lbl_title.innerText = gdp_version;
			status_data = READY_TO_PLAY;
			//status_timeout = 10;
			status_enabled = false;
		break;
		case 1: //station + group
			status_timeout = 10;
			//id = System.Gadget.Settings.read("last_stream");
			try {
				document.getElementById("lbl_station").innerHTML =  "<a href='javascript:fnGetMediaInfo();'>" + stream[id].name + "</a>"; //np_station;
				status_data = stream[id].group;
				//lbl_title.innerText = stream[id].url;
				temp_id = id;
				if (player.playState == 3) { 
					btn_playstop.src = "images/btn_stop.png";
					document.getElementById("btn_playstop").onclick= function() { fnStop(); }
					fnChangeTooltips(getValue("last_stream"));
					btn_playstop.alt = STOP;
				} else {
					lbl_title.innerText = gdp_version;
				}
			} catch(e) {
				lbl_station.innerText = "";
			}
		break;
		case 2: //wmp status
			status_data = fnGetPlayerState();
			status_timeout = 10;
		break;
		case 3: //station's homepage
			if (!stream.length > 0) { return; }
			status_data = "<a href='" + stream[id].homepage + "'>" + stream[id].homepage + "</a>";
			status_timeout = 10;
		break;
		case 4:
			status_data = "";
		break;
		case 95: //update available
			status_data = "<a href='http://gdplayer.blogspot.com/p/download.html'>" + DOWNLOAD + "</a>";
			status_timeout = 10;
			status_enabled = false;
		break;
		case 96: //url error
			lbl_title.innerText = "no signal";
			status_enabled = true;
			status_timeout = 5;
		break;
		case 97: //prev / next
			status_data = stream[temp_id].group;
			lbl_station.innerText = stream[temp_id].name;
			fnChangeTooltips(temp_id);
			status_enabled = true;
			status_timeout = 5;
		break;
		case 98: //volume
			status_data = VOLUME + " : " + player.settings.volume  + "%";
			status_enabled = true;
			status_timeout = 5;
		break;
		case 99: //error - stream[] - fail
			lbl_station.innerText = "";
			lbl_title.innerText = "";
			status_data = " - - - ";
			status_enabled = true;
			status_timeout = 5;
		break;
	}
	
	if (player.playstate == 3) { 
		lbl_title.innerText = player.currentMedia.getItemInfo('Title'); 
		
		var data = "<a href='http://www.google.com/search?q=" + player.currentMedia.getItemInfo('Title') + "'><img src='images/btn_search.png' alt='Google: " + player.currentMedia.getItemInfo('Title') + "'></a>";		
		lbl_search.innerHTML = data;
		
	}
	lbl_status.innerHTML = status_data;

	++status_bank;
	if (status_bank >= 4) { status_bank = 1; }
}
function fnIsAnimating() {
	if (anim != null) {
		clearInterval(anim);
		anim = null;
	}
}
function fnStatusFadeOut() {
	fnIsAnimating();
	opacity = 100;
	anim = setInterval(AnimateOut,20);
	
}
function fnStatusFadeIn() {
	fnIsAnimating();
	opacity = 0;
	anim = setInterval(AnimateIn,20);
}
function AnimateOut() {
	--opacity;
	document.getElementById("lbl_status").style.filter = 'alpha(opacity=' + opacity + ')';
	if (opacity == 0) {
		clearInterval(anim);
		fnRefreshStatus();
		fnStatusFadeIn();
	}
}
function AnimateIn() {
	++opacity;
	document.getElementById("lbl_status").style.filter = 'alpha(opacity=' + opacity + ')';
	if (opacity == 100) {
		clearInterval(anim);
		status_enabled = true; 
	}
}

function fnPlayerStateChanged() {
	status_bank = 2;
	fnRefreshStatus();
}
//-------------------------------------- TIME UPDATE
function fnTimeUpdate() {
	if (status_enabled == true) {
		--status_timeout;
		if (status_timeout == 3) {
			status_enabled = false;
			fnStatusFadeOut();
		}
	}
	
	if (!date_time) { return; }

	var time = new Date();
	var hours = time.getHours();
	var minutes = time.getMinutes();
	var month=new Array(12);
		month[0] = M0;
		month[1] = M1;
		month[2] = M2;
		month[3] = M3;
		month[4] = M4;
		month[5] = M5;
		month[6] = M6;
		month[7] = M7;
		month[8] = M8;
		month[9] = M9;
		month[10] = M10;
		month[11] = M11;
	var day=new Array(7);
		day[0]=D0;
		day[1]=D1;
		day[2]=D2;
		day[3]=D3;
		day[4]=D4;
		day[5]=D5;
		day[6]=D6;
		
	var date = day[time.getDay()] + " " + time.getDate() + " " + month[time.getMonth()];

	minutes = (minutes < 10 ? "0" : "") + minutes;

	//if (getValue("am_pm") == false) {
	if (am_pm == false) {
		lbl_ampm.innerText = "  ";
		lbl_time.style.width = "65";
	} else {
		lbl_time.style.width = "50";
		lbl_ampm.innerText = (hours < 12) ? "AM" : "PM";
		hours = (hours > 12) ? hours - 12 : hours;
		hours = (hours == 0) ? 12 : hours;
	}

	lbl_time.innerText = hours + ":" + minutes;
	lbl_date.innerText = date;
}

//-------------------------------------- GET PLAYER STATE
function fnGetPlayerState() {
	var x = player.playState;
	switch(x) {
		case 0: return IDLE;
		case 1: return STOPPED;
		case 2: return PAUSED;
		case 3: 
				var att_value =  player.currentMedia.getItemInfo('Title');
				lbl_title.innerText = att_value;
				return PLAYING + " : " + parseInt(player.network.bitRate/1000) +" Kbps";
		break;
		case 4: return "";
		case 5: return ""; 
		case 6: return BUFFERING;
		case 7: return WAITING;
		case 8: return MEDIA_ENDED;
		case 9: return TRANSITIONING;
		case 10: return READY_TO_PLAY
		case 11: return RECONECTING;
	}
}

//-------------------------------------- FADE IN / OUT
function fnFadeIn() {
	if (date_time) { time.style.visibility='hidden'; }
	lbl_title.style.visibility='hidden';
	buttons.style.visibility='visible';
	menu.style.visibility='visible';
	mute.style.visibility='visible';
	lbl_search.style.visibility='visible';
	volume_bar.style.visibility='visible';
}

function fnFadeOut() {
	if (date_time) { time.style.visibility='visible'; }
	lbl_title.style.visibility='visible';
	buttons.style.visibility='hidden';
	menu.style.visibility='hidden';
	mute.style.visibility='hidden';
	lbl_search.style.visibility='hidden';
	volume_bar.style.visibility='hidden';
}

//--------------------------------------  MENU
function fnMenu() {
	System.Gadget.Flyout.file = "menu.html";
	System.Gadget.Flyout.show = true;
	var flyoutDoc = System.Gadget.Flyout.document;
	System.Gadget.Flyout.onShow = function() {
		flyoutDoc.getElementById("info").innerHTML = "<b>Playlist:</b> " + stream.length + " " + OPT_STATIONS;
	}
}

function fnStream(itemText) {
	for (var i=0; i<stream.length; ++i) {
		if (itemText == stream[i].name) {
			id = i;
			//options.putValue("last_stream",id);
			fnPlay();
		}
	}
}

//-------------------------------------- GET MEDIA INFO
function fnGetMediaInfo() {
	if (player.currentMedia != null) {
		var att_num = player.currentMedia.attributeCount;
		var a = "";
		var b = "";
		b += "<b>" + stream[id].group + "</b>";
		b += "<div class='head'>" + stream[id].name + "</div>";
		b += "<div class='details'><a href='" + stream[id].homepage + "'><b>" + stream[id].homepage + "</b></a></div>";

		a += "<table>";
		for (var i=0; i<att_num; ++i) {
			var att_name = player.currentMedia.getAttributeName(i);
			var att_value = player.currentMedia.getItemInfo(att_name);
			var att_temp = att_name.toLowerCase();
			
			if (att_name == "Title") { var title = att_value; }
			a += "<tr><td valign='top'><b>" + att_name + "</b></td>";
			a += "<td>";
			if (att_temp.indexOf("url") != -1) {
				a += "<a href='" + att_value + "'>" + att_value + "</a>";
			} else {
				a += att_value;
			}
			a += "</td></tr>";
		}
		a += "</table>";

		fnViewHTML(a,b);
	}
}

//-------------------------------------- SHOW HTML DETAILS
function fnViewHTML(data,head) {
	System.Gadget.Flyout.file = "flyout.html";
	System.Gadget.Flyout.show = true;
	var flyoutDoc = System.Gadget.Flyout.document;
	System.Gadget.Flyout.onShow = function() {
		flyoutDoc.getElementById("head").innerHTML = head;
		flyoutDoc.getElementById("data").innerHTML = data;
		flyoutDoc.getElementById("data").enabled = true;
	}
}

//-------------------------------------- CHECK GADGET DOCKED STATE
function fnChkState() {
    if (System.Gadget.docked) { 
        fnIsDocked();
    } else {
        fnIsUndocked();
    }
}
//-------------------------------------- UNDOCKED
function fnIsUndocked() {	
	with (document.body.style) { width = "200px"; }
	document.getElementById("bgrd").src = "images/bgrd_" + bgrd_id + "_undocked.png";
	document.getElementById("bgrd").style.width = "200px";
	document.getElementById("main").style.width = "200px";
	document.getElementById("lbl_station").style.width = "190px";
	document.getElementById("lbl_status").style.width = "190px";
	document.getElementById("buttons").style.width = "190px";
	document.getElementById("mute").style.left = "182px";
	document.getElementById("time").style.left = "131px";
	document.getElementById("volume_bar").style.left = "47px";

	if (date_time) { 
			lbl_station.align = "left"; 
			lbl_title.align = "left";
			document.getElementById("lbl_title").style.width = "130px";
			lbl_status.align = "left";
	} else {
			lbl_station.align = "center"; 
			lbl_title.align = "center";
			document.getElementById("lbl_title").style.width = "190px";
			lbl_status.align = "center";
	}
}
//-------------------------------------- DOCKED
function fnIsDocked() {
    with (document.body.style) { width = "130px"; }
	document.getElementById("bgrd").src = "images/bgrd_" + bgrd_id + "_docked.png";
	document.getElementById("bgrd").style.width = "130px";
	document.getElementById("main").style.width = "130px";
	document.getElementById("lbl_station").style.width = "120px";
	document.getElementById("lbl_status").style.width = "118px";
	document.getElementById("buttons").style.width = "120px";
	document.getElementById("mute").style.left = "112px";
	document.getElementById("time").style.left = "61px";
	document.getElementById("volume_bar").style.left = "12px";
	
	 if (date_time) { 
			lbl_station.align = "left"; 
			lbl_title.align = "left";
			document.getElementById("lbl_title").style.width = "60px";
			lbl_status.align = "left";
	} else {
			lbl_station.align = "center"; 
			lbl_title.align = "center";
			document.getElementById("lbl_title").style.width = "120px";
			lbl_status.align = "center";
	} 
}

//---------------------------------------------------------------------------------------------------------- UPDATES
function fnChkUpdates() {
	var req = new XMLHttpRequest();
	//var url = "http://127.0.0.1/gdplayer/version.txt?r=" + Math.random();
	var url = "http://gdplayer.4fan.cz/gdplayer/version.txt?r=" + Math.random();
	
	//alert("downloading: " + url);
	req.open("GET", url, true);
	req.onreadystatechange = function() {
		if (req.readyState == 4 && req.status == 200) {
			//alert("version.txt is loaded & ready for use...");
			var ver_online = req.responseText;
			if (ver_online > version) { 
				lbl_title.innerText = NEW_VERSION;
				status_bank = 95;
				fnRefreshStatus();
			}
		}
    };
	req.send();
}

//---------------------------------------------------------------------------------------------------------- CHANGE TOOLTIPS
function fnChangeTooltips(st_id) {
	if(stream.length > 0) {
		st_id == 0 ? btn_prev.alt = PREVIOUS + " (" + stream[stream.length - 1].name + ")" : btn_prev.alt = PREVIOUS + " (" + stream[st_id -1].name + ")";
		st_id == stream.length - 1 ? btn_next.alt = NEXT + " (" + stream[0].name + ")" : btn_next.alt = NEXT + " (" + stream[st_id + 1].name + ")";
		btn_playstop.alt = PLAY + " (" + stream[st_id].name + ")";
	} else {
		btn_prev.alt = PREVIOUS;
		btn_next.alt = NEXT;
		btn_playstop.alt = PLAY;
	}
}

