﻿// gdplayer 0.9.3 Vista/7
// 10.12.2010
// Copyright 2009 - 2010 Zdenek Canik
// All Rights Reserved.
// http://gdplayer.blogspot.com

var opt_stream = new Array();
var opt_group = new Array();
var opt_id = 0;
var np_id = System.Gadget.Settings.read("last_stream");


function onOpen() {
	fnGetDefaultPlaylist();
}

function fnGetDefaultPlaylist() {
	//alert("options : loading local playlist...");
	var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
	try {
		xmlDoc.async = false;
		var result = xmlDoc.load("gdplayer_playlist.xml");
		if (!result) {
			//alert("local gdplayer_playlist.xml : not found");
			return;
		}
		//alert("gdplayer_playlist.xml is loaded & ready for use...");
		fnGetData(xmlDoc);
		fnUpdateLstGroups();
	} catch(e) {
		//alert(e.message);
	}
}
function fnGetData(data) {
	opt_group = [];
	opt_stream = [];

	var parseError = data.parseError;
	if (parseError.errorCode != 0) { debug.error(parseError.reason); }
	var objGroupList = data.getElementsByTagName("group");
	//alert("found : " + objGroupList.length + " group(s)");

	var id=-1;
	for (var i = 0; i < objGroupList.length; ++i) {
		var xmlItem = objGroupList.item(i);
		opt_group[i] = xmlItem.getAttribute("name");
		
		for (var j = 0; j < xmlItem.childNodes.length; j++) {
			var child = xmlItem.childNodes.item(j);
			if (child.childNodes.length > 0) {
				++id;
				try {
					var http = child.childNodes[2].childNodes[0].nodeValue;
				} catch (e) {
					var http = "none";
				}
				opt_stream[id] = {
					name:child.childNodes[0].childNodes[0].nodeValue,
					url:child.childNodes[1].childNodes[0].nodeValue,
					homepage:http,
					group:opt_group[i]
				};
			}
		}
	}
}

// ------------------------------------------------------------------- GROUP TOOLS
function fnUpdateLstGroups(data) {
	lst_groups.options.length = opt_group.length;
	if(!np_id) { np_id = 0; }
	for (var i = 0; i < opt_group.length; i++) {
		lst_groups.options[i].text = opt_group[i];
		if  (np_id >= 0) { 
			if (opt_group[i] == opt_stream[np_id].group) { lst_groups.selectedIndex = i; }
		} else {
			lst_groups.selectedIndex = 0; 
		}
	}
	fnUpdateLstStreams();
}

// ------------------------------------------------------------------- STREAMS TOOLS
function fnUpdateLstStreams() {
	if (opt_stream.length == 0) { return; }
	var id =lst_groups.selectedIndex;
	lst_stations.options.length = 0;
	var x = -1;
	for (var i = 0; i < opt_stream.length; i++) {	
		if (opt_stream[i].group == lst_groups.options[id].text) {
			lst_stations.options.length++;
			x++;
			lst_stations.options[x].text = opt_stream[i].name;
			if (i == np_id) { lst_stations.selectedIndex = x; }
		}
	}	
}

//----------------------------------------------------------------------------------- GET ID!
function fnGetId() {
	try {
		var name = lst_stations.options[lst_stations.selectedIndex].text;	
		var group = opt_group[lst_groups.selectedIndex];
	} catch(e) { 
		return; 
	}
	var id = null;
	
	for (var i = 0; i < opt_stream.length; i++) {
		if (group == opt_stream[i].group && name == opt_stream[i].name) { id = i; }
	}	
	//alert("fnGetId : [" + id + "] " + name + " - " + group);
	opt_id = id;
	return id;
}

function fnPlayID() {
	var id = fnGetId();
	var temp_id = id;
	if (id == null) { return; }
	System.Gadget.document.parentWindow.id = id;
	System.Gadget.document.parentWindow.temp_id = temp_id;
	System.Gadget.document.parentWindow.fnPlay();
}